/* Copyright (c) 2009 Ondrej Donek.
   See the file LICENSE.txt for licensing information. */

/**
 * Handler for our note column in the main Thunderbird's messages tree.
 * 
 * @todo Sorting is not working!!!
 * 
 * @link http://developer.mozilla.org/en/Extensions/Thunderbird/Creating_a_Custom_Column 
 * @type Object
 */
var gTbNotesColumnHandler = {

	getCellText: function(aRow, aCol) {
		// We have image not a string
		return "";
	},

	getImageSrc: function(aRow, aCol) {
		var key  = gDBView.getKeyAt(aRow);
		
		//CU.reportError("KEY: " + key);
		
		// TODO This can be quit slowly when we have a lot of messages to check.
		//      Maybe will better to get all messages at once and check only if 
		//      target key is present in that array ...
		// TODO This is wrong because this handler is used not only for messages
		//      view but also for others (news etc.)
		
		//var selMsg = gFolderDisplay.selectedMessage;
		//var isNews = gFolderDisplay.selectedMessageIsNews;
		//var isFeed = gFolderDisplay.selectedMessageIsFeed;
		//var folder = gFolderDisplay.displayedFolder;
		//var winType = document.documentElement.getAttribute('windowtype'); // mail:3pane
		
		//CU.reportError("Selected message is news: " + ((isNews) ? "yes" : "no"));
		//CU.reportError("Selected message is feed: " + ((isFeed) ? "yes" : "no"));
		//CU.reportError("Displayed folder: " + folder);
		//CU.reportError("Folder's URI: " + folder.URI);
		//CU.reportError("Folder's server: " + folder.server);
		//CU.reportError("Folder is special: " + ((folder.isSpecialFolder) ? "yes" : "no"));
		//CU.reportError("Windows type: " + winType);
		
		//var t="";
		//for(var p in folder) t = t+"["+p+"]";
		//CU.reportError(t);
		
		var note = extensions.tbnotes.checkNoteForTargetKey(key);
		
		return (note === true) 
				? TBNOTES_MSGHASNOTE_ICON_URL 
				: TBNOTES_MSGHASNONOTE_ICON_URL;
	},

	isString: function() { 
		return false; 
	},

	getSortStringForRow: function(aHdr) {
		// TODO Should I return `ascending`|`descending`|`notsorted` here?
		return "";
	},

	getCellProperties: function(aRow, aCol, aProps) {},
	getRowProperties: function(aRow, aProps) {},
	getSortLongForRow: function(aHdr) { 
		return 0; 
	}
	
};

/**
 * Implements Components.interfaces.nsIObserver for message "MsgCreateDBView".
 * 
 * @type Object
 */
var gTbNotesCreateDbObserver = {

	observe: function(aMsgFolder, aTopic, aData) {  
		gDBView.addColumnHandler("tbn-note-treecol", gTbNotesColumnHandler);
	}
	
};


// ============================================================================
// Add on load event listener

window.addEventListener("load", extensions.tbnotes.onLoad, false);

